#include common_scripts\utility;
#include maps\mp\_utility;
#include maps\mp\gametypes\_gamelogic;
#include maps\mp\bots\_bots_util;
#include maps\mp\bots\_bots_strategy;
#include maps\mp\bots\_bots_personality;
#include maps\mp\bots\_bots_gametype_common;

main()
{
	// This is called directly from native code on game startup after the _bots::main() is executed
	setup_callbacks();
	setup_bot_gun();
}

setup_callbacks()
{
	level.bot_funcs["gametype_think"] = ::bot_gun_think;
}

setup_bot_gun()
{
}

bot_gun_think()
{
	self notify( "bot_gun_think" );
	self endon(  "bot_gun_think" );

	self endon( "death" );
	self endon( "disconnect" );
	level endon( "game_ended" );
	self endon( "owner_disconnect" );
	
	// This game mode just performs normal personality logic
	while ( true )
	{
		self [[ self.personality_update_function ]]();
		wait(0.05);
	}
}