/*
	maps\mp\[mapname]_lighting.gsc
	
	script for mp level-scripting
*/

#include maps\mp\_mp_lights;

main()
{

	setdvar( "r_lightGridEnableTweaks", 1 );
	setdvar( "r_lightGridIntensity", 1.33 );
	 
	setdvar( "r_volumeLightScatterUseTweaks", "1" );
	setdvar( "r_lightGridEnableTweaks", "1" );
	setdvar( "r_lightGridIntensity", "1.33" );
	setdvar( "r_volumeLightScatter", "1" );
	setdvar( "r_volumeLightScatterUseTweaks", "1" );
	setdvar( "r_volumeLightScatterAngularAtten", ".05" );
	setdvar( "r_volumeLightScatterColor", ".96  0.96 0.94" );
	setdvar( "r_volumeLightScatterLinearAtten", "1" );
	setdvar( "r_volumeLightScatterEV", "14" );
	
	
	
	    //Character vis
    setdvar( "r_mpRimColor", ".8 .8 .6 0" );
    setdvar( "r_mpRimStrength", "0" );
    setdvar( "r_mpRimDiffuseTint", "1.2 1.5 1.5" );
    //setdvar( "r_mpRimLightPitch", "-59" );
   //setdvar( "r_mpRimLightHeading", "167" );
   //setdvar( "r_mpRimLightPower", "2" );
   
	//r_gunSightColorEntityScale needs to be set to tune the iron sights color shader (mtl_iron_sights_color). 
	//A change was made to fix the brightness, but causes untuned instances to be too bright. This will need to be tuned for every level.
	setdvar( "r_gunSightColorEntityScale", "7" );
	setdvar( "r_gunSightColorNoneScale", "0.8" );
	
	
   if(level.currentgen)
   {
   		setdvar("r_dof_tweak", 2);
   }

}
