/*
	maps\mp\[mapname]_lighting.gsc
	
	script for mp level-scripting
*/
#include maps\mp\_mp_lights;

main()
{
	setdvar( "r_lightGridEnableTweaks", 1 );
	setdvar( "r_lightGridIntensity", 1.33 );
	
	//Character vis
	setdvar( "r_mpRimColor", "0.8 0.6 0.3" );
	setdvar( "r_mpRimStrength", "10" );
	setdvar( "r_mpRimDiffuseTint", "1.5 1.5 1.5" );
	//Volume light scattering

	//r_gunSightColorEntityScale needs to be set to tune the iron sights color shader (mtl_iron_sights_color). 
	//A change was made to fix the brightness, but causes untuned instances to be too bright. This will need to be tuned for every level.
	setdvar( "r_gunSightColorEntityScale", "7" );
	setdvar( "r_gunSightColorNoneScale", "0.8" );

	if( level.currentgen )
	{
		setDvar( "r_specularcolorscale", 1.0 );
	}
	
	init();
	//thread fire_flicker();
}

fire_flicker()
{
	play_flickerLight_preset("fire", "fire_flicker", 3000);
}
