/*
	maps\mp\[mapname]_lighting.gsc
	
	script for mp level-scripting
*/

main()
{
	thread set_level_lighting_values();
}

set_level_lighting_values()
{
	if ( IsUsingHDR() )
	{
		thread setup_lighting();
	}
}

setup_lighting()
{
	
	setdvar( "r_lightGridEnableTweaks", 1 );
	setdvar( "r_lightGridIntensity", 1.33 );
	
	//r_gunSightColorEntityScale needs to be set to tune the iron sights color shader (mtl_iron_sights_color). 
	//A change was made to fix the brightness, but causes untuned instances to be too bright. This will need to be tuned for every level.
	setdvar( "r_gunSightColorEntityScale", "7" );
	setdvar( "r_gunSightColorNoneScale", "0.8" );
	
//	SetDvar("r_dof_enable", 1);
//	SetDvar("r_dof_tweak", 1);
//	SetDvar("r_dof_physical_enable", 1);
//    	SetDvar("r_dof_physical_hipenable", 1);
// 	SetDvar("r_dof_physical_hipFstop", 42);
//   	SetDvar("r_dof_physical_hipSharpCocDiameter", 0.25); 	

}
