/*
	maps\mp\[mapname]_lighting.gsc
	
	script for mp level-scripting
*/

main()
{
	setdvar( "r_lightGridEnableTweaks", 1 );
	setdvar( "r_lightGridIntensity", 1.33 );
	//Character vis
	setdvar( "r_mpRimColor", "0 0 0" );
	setdvar( "r_mpRimStrength", "0" );
	setdvar( "r_mpRimDiffuseTint", "0 0 0" );
	//Screen Space Refrection Quality setting
	//setdvar( "r_screenSpaceReflectionHQ", 1 ); // commented out for now based on rendering team recommendations
	setdvar( "sm_spotshadowfadetime", 0.01 );
	setdvar( "sm_spotLightScoreModelScale", 0.3 );
	// testing the scripted lighting centroid
	//vl_char_lighting();
	
	//r_gunSightColorEntityScale needs to be set to tune the iron sights color shader (mtl_iron_sights_color). 
	//A change was made to fix the brightness, but causes untuned instances to be too bright. This will need to be tuned for every level.
	setdvar( "r_gunSightColorEntityScale", "7" );
	setdvar( "r_gunSightColorNoneScale", "0.8" );
	
}

// vl_lightscore_booster()
//{ 
// 	lgts = GetEntArray( "light_score_booster", "targetname" );
// 	foreach (lgt in lgts)
// 	{
// 		lgt_intensity = lgt GetLightIntensity();
// 		lgt SetLightIntensity(5000);
// 	}
//}
// 
 	

// testing the scripted lighting centroid
/*
 vl_char_lighting()
{    
    //assign the new lighting centroid to the tree
    modified_centroid = GetEnt( "modified_char_centroid", "targetname" );
 
    //get the tree entity
    npc = GetEnt( "player_pos", "targetname" );
 
    //use the new lighting origin on the tree entity
    npc OverrideLightingOrigin(modified_centroid.origin);
}
*/


