/*
	maps\mp\[mapname]_lighting.gsc
	
	script for mp level-scripting
*/

main()
{
	setdvar( "r_lightGridEnableTweaks", 1 );
	setdvar( "r_lightGridIntensity", 1.33 );
	
		//Character vis
	setdvar( "r_mpRimColor", ".7 .9 1" );
	setdvar( "r_mpRimStrength", "7" );
	setdvar( "r_mpRimDiffuseTint", ".77 .85 1.1" );
	
	
	//r_gunSightColorEntityScale needs to be set to tune the iron sights color shader (mtl_iron_sights_color). 
	//A change was made to fix the brightness, but causes untuned instances to be too bright. This will need to be tuned for every level.
	setdvar( "r_gunSightColorEntityScale", "7" );
	setdvar( "r_gunSightColorNoneScale", "0.8" );
	
	if(level.currentgen)	
	{
		// Setting a map-specific OSP vision set.
		level.ospvisionset = "mp_levity_osp";
		level.ospLightSet = "mp_levity_osp";
	
		// Setting a map-specific warbird vision set.
		level.warbirdVisionSet = "mp_levity_warbird";
		level.warbirdLightSet = "mp_levity_warbird";
	
		//Setting a map-specific drone vision set.
		level.droneVisionSet = "mp_levity_drone";
		level.droneLightSet = "mp_levity_drone";
	}
	
}

