/*
	maps\mp\[mapname]_lighting.gsc
	
	script for mp level-scripting
*/

main()
{
	setdvar( "r_lightGridEnableTweaks", 1 );
	setdvar( "r_lightGridIntensity", 1.33 );
	
	
	//Char Vis
	setdvar( "r_mpRimColor", "1.75 1.4 1.1" );
	setdvar( "r_mpRimStrength", "1" );
	setdvar( "r_mpRimDiffuseTint", "2.25 2 1.75" );

	//r_gunSightColorEntityScale needs to be set to tune the iron sights color shader (mtl_iron_sights_color). 
	//A change was made to fix the brightness, but causes untuned instances to be too bright. This will need to be tuned for every level.
	setdvar( "r_gunSightColorEntityScale", "7" );
	setdvar( "r_gunSightColorNoneScale", "0.8" );
}

